Draft BezCurve
|
Menu location |
---|
Drafting → Bézier tools → Bézier curve 2D Drafting → Bézier curve |
Workbenches |
Draft, BIM |
Default shortcut |
B Z |
Introduced in version |
0.14 |
See also |
Draft CubicBezCurve, Draft BSpline |
Description
The Draft BezCurve command creates a Bézier curve from several points.
The command creates a single Bézier curve with a DataDegree that is number_of_points - 1
. It can be transformed into a piecewise Bézier curve by reducing this property.
The Draft BezCurve and the Draft CubicBezCurve commands use control points to define the position and curvature of the spline. The Draft BSpline command, on the other hand, specifies the exact points through which the curve will pass.
Bézier curve defined by multiple points
Usage
See also: Draft Tray, Draft Snap and Draft Constrain.
- There are several ways to invoke the command:
- Press the
Bézier curve button.
- Draft: Select the Drafting → Bézier tools →
Bézier curve option from the menu.
- BIM: Select the 2D Drafting →
Bézier curve option from the menu.
- Use the keyboard shortcut: B then Z. introduced in version 0.20
- Press the
- The Bézier curve task panel opens. See Options for more information.
- Pick the first point in the 3D view, or type coordinates and press the
Enter point button.
- Pick additional points in the 3D view, or type coordinates and press the
Enter point button.
- Press Esc or the Close button to finish the command.
Options
The single character keyboard shortcuts available in the task panel can be changed. See Draft Preferences. The shortcuts mentioned here are the default shortcuts (for version 1.0).
- To manually enter coordinates enter the X, Y and Z component, and press Enter after each. Or you can press the
Enter point button when you have the desired values. It is advisable to move the pointer out of the 3D view before entering coordinates.
- Press R or click the Relative checkbox to toggle relative mode. If relative mode is on, coordinates are relative to the last point, if available, else they are relative to the coordinate system origin.
- Press G or click the Global checkbox to toggle global mode. If global mode is on, coordinates are relative to the global coordinate system, else they are relative to the working plane coordinate system. introduced in version 0.20
- Press F or click the Filled checkbox to toggle filled mode. If filled mode is on, the created curve will have DataMake Face set to
true
and will have a filled face, provided it is closed and does not self-intersect. Note that a self-intersecting curve with a face will not display properly, for such a curve DataMake Face must be set tofalse
. - Press N or click the Continue checkbox to toggle continue mode. If continue mode is on, the command will restart after using
Finish or
Close, or after creating a closed curve by snapping to the first point of the curve, allowing you to continue creating curves.
- Press / or the
Undo button to undo the last point.
- Press A or the
Finish button to finish the command and leave the curve open.
- Press O or the
Close button to finish the command and close the curve. A closed curve can also be created by snapping to the first point of the curve.
- Press W or the
Wipe button to delete the segments already placed, but keep working from the last point.
- Press U or the
Set WP button to adjust the current working plane in the orientation defined by the last and the previous point.
- Press S to switch Draft snapping on or off.
- Press Esc or the Close button to finish the command.
Notes
- A Draft BezCurve can be edited with the Draft Edit command.
- OpenCascade, and therefore FreeCAD, does not support Bézier curves of degrees larger than 25. This should not be a problem in practice, as most users typically use Bézier curves of degrees 3 to 5.
Properties
See also: Property editor.
A Draft BezCurve object is derived from a Part Part2DObject and inherits all its properties. It also has the following additional properties:
Data
Draft
- DataArea (
Area
): (read-only) specifies the area of the face of the curve. The value will be0.0
if DataMake Face iffalse
or the face cannot be created. - DataClosed (
Bool
): specifies if the curve is closed or not. If the curve is initially open this value isfalse
, setting it totrue
will draw a segment to close the curve. If the curve is initially closed this value istrue
, setting it tofalse
will remove the last segment and make the curve open. - DataContinuity (
IntegerList
): (read-only) specifies the continuity of the curve. - DataDegree (
Integer
): specifies the degree of the curve. - DataLength (
Length
): (read-only) specifies the total length of the curve. - DataMake Face (
Bool
): specifies if the curve makes a face or not. If it istrue
a face is created, otherwise only the perimeter is considered part of the object. This property only works if DataClosed istrue
and if the curve does not self-intersect. - DataPoints (
VectorList
): specifies the control points of the curve in its local coordinate system.
View
Draft
- ViewArrow Size (
Length
): specifies the size of the symbol displayed at the end of the curve. - ViewArrow Type (
Enumeration
): specifies the type of symbol displayed at the end of the curve, which can beDot
,Circle
,Arrow
,Tick
orTick-2
. - ViewEnd Arrow (
Bool
): specifies whether to show a symbol at the end of the curve, so it can be used as an annotation line. - ViewPattern (
Enumeration
): specifies the Draft Pattern with which to fill the face of the closed curve. This property only works if DataMake Face istrue
and if ViewDisplay Mode isFlat Lines
. - ViewPattern Size (
Float
): specifies the size of the Draft Pattern.
Scripting
See also: Autogenerated API documentation and FreeCAD Scripting Basics.
To create a Draft Line use the make_bezcurve
method (introduced in version 0.19) of the Draft module. This method replaces the deprecated makeBezCurve
method.
bezcurve = make_bezcurve(pointslist, closed=False, placement=None, face=None, support=None, degree=None)
bezcurve = make_bezcurve(Part.Wire, closed=False, placement=None, face=None, support=None, degree=None)
- Creates a
bezcurve
object with the given list of points,pointslist
.- Each point in the list is defined by its
FreeCAD.Vector
, with units in millimeters. - Alternatively, the input can be a
Part.Wire
, from which points are extracted.
- Each point in the list is defined by its
- If
closed
isTrue
, or if the first and last points are identical, the curve is closed. - If
placement
isNone
the curve is created at the origin. - If
face
isTrue
, and the curve is closed, the curve will make a face, that is, it will appear filled.
Example:
import FreeCAD as App
import Draft
doc = App.newDocument()
p1 = App.Vector(0, 0, 0)
p2 = App.Vector(1000, 1000, 0)
p3 = App.Vector(2000, 0, 0)
p4 = App.Vector(1500, -2000, 0)
bezcurve1 = Draft.make_bezcurve([p1, p2, p3, p4], closed=True)
bezcurve2 = Draft.make_bezcurve([p4, 1.3*p2, p1, 4.1*p3], closed=True)
bezcurve3 = Draft.make_bezcurve([1.7*p3, 1.5*p4, 2.1*p2, p1], closed=True)
doc.recompute()
- Drafting: Line, Polyline, Fillet, Arc, Arc by 3 points, Circle, Ellipse, Rectangle, Polygon, B-spline, Cubic Bézier curve, Bézier curve, Point, Facebinder, ShapeString, Hatch
- Annotation: Text, Dimension, Label, Annotation styles, Annotation scale
- Modification: Move, Rotate, Scale, Mirror, Offset, Trimex, Stretch, Clone, Array, Polar array, Circular array, Path array, Path link array, Point array, Point link array, Edit, Subelement highlight, Join, Split, Upgrade, Downgrade, Wire to B-spline, Draft to sketch, Set slope, Flip dimension, Shape 2D view
- Draft Tray: Select plane, Set style, Toggle construction mode, AutoGroup
- Snapping: Snap lock, Snap endpoint, Snap midpoint, Snap center, Snap angle, Snap intersection, Snap perpendicular, Snap extension, Snap parallel, Snap special, Snap near, Snap ortho, Snap grid, Snap working plane, Snap dimensions, Toggle grid
- Miscellaneous: Apply current style, Layer, Manage layers, Add a new named group, Move to group, Select group, Add to construction group, Toggle normal/wireframe display, Create working plane proxy, Heal, Show snap toolbar
- Additional: Constraining, Pattern, Preferences, Import Export Preferences, DXF/DWG, SVG, OCA, DAT
- Context menu:
- Layer container: Merge layer duplicates, Add new layer
- Layer: Activate this layer, Select layer contents
- Text: Open hyperlinks
- Wire: Flatten
- Working plane proxy: Write camera position, Write objects state

- Getting started
- Installation: Download, Windows, Linux, Mac, Additional components, Docker, AppImage, Ubuntu Snap
- Basics: About FreeCAD, Interface, Mouse navigation, Selection methods, Object name, Preferences, Workbenches, Document structure, Properties, Help FreeCAD, Donate
- Help: Tutorials, Video tutorials
- Workbenches: Std Base, Assembly, BIM, CAM, Draft, FEM, Inspection, Material, Mesh, OpenSCAD, Part, PartDesign, Points, Reverse Engineering, Robot, Sketcher, Spreadsheet, Surface, TechDraw, Test Framework
- Hubs: User hub, Power users hub, Developer hub